#include<LEDA/graph/graph.h>
#include<LEDA/core/array.h>
#include<LEDA/numbers/integer.h>
#include<iostream>
using namespace leda;
using namespace std;

integer algorithm(graph &G);
int complete_g(graph &G);
integer calculation(graph &G);
edge add_e(graph &G);
void contraction(graph &G,edge e);

integer color = 6;

int main()
{
  graph G;
  G.read("graph.gw");

  G.make_undirected();
  cout << algorithm(G) << endl;
}

integer algorithm(graph &G)
{

  if( complete_g(G) )
    return calculation(G);

  graph G_2 = G;
  edge e = add_e(G_2);

  graph G_1 = G_2;
  contraction(G_2,e);

  integer p_1 = algorithm(G_1);
  integer p_2 = algorithm(G_2);

  return p_1 + p_2;
}

int complete_g(graph &G)
{
  node v;
  int i = G.number_of_nodes();

  int sum = 0;
  for(i=i-1;i>0;i--)
    sum += i;

  if(G.number_of_edges() == sum )
    return 1;
  else return 0;
}

integer calculation(graph &G)
{
  integer n = G.number_of_nodes();

  integer col=1;

  for(integer i=0;i<n;i++)
    col = col * (color-i);

  return col;
}

edge add_e(graph &G)
{
  int n = G.number_of_nodes();
  node v;
  node_array<int> n_a(G,0);

  for(;;){
    v = G.choose_node();
    if(G.degree(v) < n-1)
      break;
  }

  n_a[v]=1;
  node w;
  forall_adj_nodes(w,v)
    n_a[w]=1;

  forall_nodes(w,G)
    if(n_a[w] == 0)
      break;

  edge e = G.new_edge(v,w);
  return e;
}

void contraction(graph &G,edge e)
{
  G.make_undirected();

  node v,w,x;

  v = G.source(e);
  w = G.opposite(v,e);

  node_array<int> node_ord(G,0);
 
  forall_adj_nodes(x,v)
    node_ord[x]=1;
  forall_adj_nodes(x,w)
    node_ord[x]=1;
  node_ord[v]=0;
  node_ord[w]=0;

  node new_v=G.new_node();
  forall_nodes(x,G)
    if(x != new_v)
      if(node_ord[x] == 1)
	G.new_edge(new_v,x);
  G.del_node(v);
  G.del_node(w);

}
